'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _interopRequire = require('babel-runtime/helpers/interop-require')['default'];

exports.__esModule = true;
exports.transform = transform;
exports.transformFile = transformFile;
exports.transformFileSync = transformFileSync;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _recast = require('recast');

var _transformAST = require('./transformAST');

var _transformAST2 = _interopRequireDefault(_transformAST);

var _buildCSS = require('./buildCSS');

var _buildCSS2 = _interopRequireDefault(_buildCSS);

var _transformObjectExpressionIntoStyleSheetObject = require('./transformObjectExpressionIntoStyleSheetObject');

exports.transformObjectExpressionIntoStyleSheetObject = _interopRequire(_transformObjectExpressionIntoStyleSheetObject);

var _transformStyleSheetObjectIntoSpecification = require('./transformStyleSheetObjectIntoSpecification');

exports.transformStyleSheetObjectIntoSpecification = _interopRequire(_transformStyleSheetObjectIntoSpecification);

var _transformSpecificationIntoCSS = require('./transformSpecificationIntoCSS');

exports.transformSpecificationIntoCSS = _interopRequire(_transformSpecificationIntoCSS);

function transform(source) {
  var options = arguments[1] === undefined ? {} : arguments[1];

  options.filename = options.filename || 'unknown';

  var stylesheets = {};
  var ast = _recast.parse(source);

  _transformAST2['default'](ast, stylesheets, options);

  var code = _recast.print(ast).code;
  var css = _buildCSS2['default'](stylesheets, options);

  return { code: code, css: css };
}

function transformFile(filename, options, callback) {
  if (typeof options === 'function') {
    callback = options;
    options = {};
  }

  options.filename = filename;

  _fs2['default'].readFile(filename, function (err, source) {
    if (err) {
      return callback(err);
    }

    var result = undefined;

    try {
      result = transform(source, options);
    } catch (exc) {
      return callback(exc);
    }

    callback(null, result);
  });
}

function transformFileSync(filename) {
  var options = arguments[1] === undefined ? {} : arguments[1];

  options.filename = filename;

  return transform(_fs2['default'].readFileSync(filename), options);
}
