'use strict';

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;
exports['default'] = generateClassName;

var _compressClassName = require('./compressClassName');

var _compressClassName2 = _interopRequireDefault(_compressClassName);

var _utilsSplitSelector = require('./utils/splitSelector');

var _utilsSplitSelector2 = _interopRequireDefault(_utilsSplitSelector);

var invalidChars = /[^_a-z0-9-]/ig;

function generateClassName(id, options) {
  var result = '';

  if (options.prefix) {
    result += options.prefix.replace(invalidChars, '_') + '-';
  } else if (options.prefixes) {
    result += options.prefixes.map(function (p) {
      return p.replace(invalidChars, '_');
    }).join('-') + '-';
  }

  result += id;

  if (options.compressClassNames) {
    var _splitSelector = _utilsSplitSelector2['default'](result);

    var className = _splitSelector[0];
    var selector = _splitSelector[1];

    return _compressClassName2['default'](className, options) + selector;
  }

  return result;
}

module.exports = exports['default'];
